<?php
/*
 +--------------------------------------------------------------------------+
 | phpMyBackupPro                                                           |
 +--------------------------------------------------------------------------+
 | Copyright (c) 2004-2005 by Dirk Randhahn                                 |
 | http://www.phpMyBackupPro.net											|
 | Version information can be found in definitions.php.                     |
 |                                                                          |
 | This program is free software; you can redistribute it and/or            |
 | modify it under the terms of the GNU General Public License              |
 | as published by the Free Software Foundation; either version 2           |
 | of the License, or (at your option) any later version.                   |
 |                                                                          |
 | This program is distributed in the hope that it will be useful,          |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of           |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            |
 | GNU General Public License for more details.                             |
 |                                                                          |
 | You should have received a copy of the GNU General Public License        |
 | along with this program; if not, write to the Free Software              |
 | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,USA.|
 +--------------------------------------------------------------------------+
*/


// standard debug function
function PMBP_debug($object) {
    echo "<pre>";
    print_r($object);
    echo "</pre>";
}


// prints the basis html header in the $lang language with $scriptname scriptname
function PMBP_print_header($scriptname) {
    global $CONF;
    echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\"
   \"http://www.w3.org/TR/html4/loose.dtd\">
<html".ARABIC_HTML.">
<head>
<title>phpMyBackupPro ".VERSION."</title>
<meta http-equiv=\"Content-Type\" content=\"text/html;charset=".BD_CHARSET_HTML."\">
<meta name=\"robots\" content=\"noindex\">
<meta name=\"robots\" content=\"nofollow\">
<link rel=\"stylesheet\" href=\"".STYLESHEET_DIR.$CONF['stylesheet'].".css\" type=\"text/css\">
";
    readfile(JAVASCRIPTS);
    // define menue
    $menu=array("index.php"=>F_START,"config.php"=>F_CONFIG,"import.php"=>F_IMPORT,"backup.php"=>F_BACKUP,"export_script.php"=>F_SCHEDULE,"db_info.php"=>F_DB_INFO,"sql_query.php"=>F_SQL_QUERY);
    $simple_width=140;
    $width=count($menu)*$simple_width;
    
    echo "</head>
<body>
<table width=\"".$width."\">
 <colgroup>
  <col span=\"".count($menu)."\" width=\"".$simple_width."\">
 </colgroup>
 <tr>
  <th colspan=\"".count($menu)."\" class=\"active\" id=\"menu\">\n";
  // print titel
  echo "<div id=\"logo\">\n";
  echo PMBP_image_tag("logo.png","phpMyBackupPro","phpMyBackupPro Homepage",WEBSITE);
  echo "&nbsp;&nbsp;".VERSION."\n";
  echo "</div>\n<div id=\"help\">\n";
    // generate popup link for proper help file
    if (!file_exists("./".LANGUAGE_DIR.$CONF['lang']."_help.php")) echo PMBP_pop_up("./".LANGUAGE_DIR."english_help.php?script=".$scriptname,PMBP_image_tag("help.gif","",F_HELP).F_HELP,"help");
        else echo  PMBP_pop_up("./".LANGUAGE_DIR.$CONF['lang']."_help.php?script=".$scriptname,PMBP_image_tag("help.gif","",F_HELP).F_HELP,"help");

	echo "\n</div>\n<div id=\"logout\">\n";
    // print logout link if function is not disabled
    if (!($CONF['no_login']=="1" && $CONF['login']=="0")) {
        echo "<a href=\"login.php?logout=TRUE\">";
        echo PMBP_image_tag("login.gif","",F_LOGOUT);
        echo F_LOGOUT."</a>\n";
    }
    echo "\n</div>\n";
	echo "  </th>\n";

// print selection for several sql servers
if (count($CONF['sql_passwd_s']) && basename($_SERVER['SCRIPT_FILENAME'])!=="config.php") {
	echo " </tr>
 <tr>
  <th colspan=\"".count($menu)."\">
  <form action=\"".basename($_SERVER['SCRIPT_NAME'])."\" method=\"POST\">
  <span class=\"bold_left\">Select working SQL server:</span>
  <select name=\"mysql_host\" onchange=\"submit()\">\n";
	if ($CONF['sql_host']==$_SESSION['sql_host_org'] && $CONF['sql_user']==$_SESSION['sql_user_org']) echo "<option value=\"-1\" selected>".$_SESSION['sql_host_org']." (".$_SESSION['sql_user_org'].")</option>\n";
	    else echo "<option value=\"-1\">".$_SESSION['sql_host_org']." (".$_SESSION['sql_user_org'].")</option>\n";
	for($i=0;$i<count($CONF['sql_passwd_s']);$i++) {
	    if (isset($CONF['sql_host_s'])) {
			if ($CONF['sql_host']==$CONF['sql_host_s'][$i] && $CONF['sql_user']==$CONF['sql_user_s'][$i]) echo "<option value=\"".$i."\" selected>".$CONF['sql_host_s'][$i]." (".$CONF['sql_user_s'][$i].")</option>\n";
				else echo "<option value=\"".$i."\">".$CONF['sql_host_s'][$i]." (".$CONF['sql_user_s'][$i].")</option>\n";
		} else {
				echo "<option value=\"".$i."\">".$CONF['sql_host_s'][$i]." (".$CONF['sql_user_s'][$i].")</option>\n";
		}
	}
	echo "  </select></form>
  </th>\n";
}

echo " </tr>
 <!-- MENU -->
 <tr>\n";

    // generate menu
    foreach($menu as $filename=>$title) {

        // print active link
        if ($filename==$scriptname && $filename!="login.php?logout=TRUE" && $filename!="HELP") {
            echo "  <th class=\"active\">\n   <a href=\"".$filename."\">".PMBP_image_tag(substr($filename,0,strpos($filename,".")).".gif","",$title).$title."</a>\n  </th>\n";

        // print lasting menu
        } elseif ($filename!="login.php?logout=TRUE" && $filename!="HELP") {
            #echo "  <th>\n   <a href=\"".$filename."\">".$title."</a>\n  </th>\n";
            echo "  <th>\n   <a href=\"".$filename."\">".PMBP_image_tag(substr($filename,0,strpos($filename,".")).".gif","",$title).$title."</a>\n  </th>\n";
        }
        
    }

    echo " </tr>
</table>
<table width=\"".$width."\">
 <colgroup>
  <col width=\"20\">
  <col width=\"*\">
  <col width=\"20\">
 </colgroup>
 <tr>
  <td>
    &nbsp;
  </td>
  <td class=\"main\">
<!-- HEADER END -->
";
}


// print basis html footer
function PMBP_print_footer() {
    echo "\n<!-- FOOTER -->
  </td>
  <td>
    &nbsp;
  </td>
 </tr>
</table>
<table width=\"980\">
 <tr>
  <th colspan=\"7\" class=\"active\">\n";
   printf(F_FOOTER,"<a href=\"".WEBSITE."\">","</a>");
   echo "\n</th>\n </tr>\n";
 
    $dontcare=array();
	// do this only once per session
    if (!isset($_SESSION['version'])) {
        // check if there is a good internet connection. If it is, look for a newer version of phpMyBackupPro
		@exec("ping -n 1 -w 1000 -l 1 phpmybackup.sourceforge.net",$dontcare,$ping_res);
	    if (!$ping_res) {
	        $_SESSION['version']=TRUE;
	        @set_time_limit("5");
	        $last_vers=@file("http://phpmybackup.sourceforge.net/vers.php?v=".VERSION);
	        $_SESSION['version']=$last_vers[0];
	    } else {
	        $_SESSION['version']=FALSE;
	    }
    }

	// new version found, print hint
    if ($_SESSION['version']) {
		echo "\n <tr>
  <td class=\"red\">
    ";
		printf(F_NOW_AVAILABLE,"<a href=\"".WEBSITE."\">","</a>");
		echo " !!!
  </td>
 </tr>\n";
    }
    
	$tmp=phpversion();
	$phpvers=$tmp[0].$tmp[1].$tmp[2];
	if ($phpvers<4.3) echo "<tr><td>PHP ".$tmp." detected. It is not recommended to use phpMyBackupPro with PHP < PHP 4.3. You can disable this message if you want in functions.inc.php line ".__LINE__.".</td></tr>";

	echo "</table>
</body>
</html>
";
}


// prints html export form used on several pages
function PMBP_print_export_form() {
    global $CONF;
    echo "\n<table width=\"940\">\n";
	echo "<tr>\n<td>\n";
    echo F_SELECT_DB.":\n";
    echo "</td>\n<td>&nbsp;</td>\n<td>";
    echo F_COMMENTS.":";
    echo "</td>\n</tr><tr>\n<td>\n";
    echo "<select name=\"db[]\" multiple=\"multiple\" size=\"10\">\n";
    if (!$con=@mysql_connect($CONF['sql_host'],$CONF['sql_user'],$CONF['sql_passwd']));

    // find the availabe compression methods and set which are disabled and which is selected
    $disabled_off=FALSE;
    if (!@function_exists("gzopen")) $disable_gzip=" disabled"; else $disable_gzip=" selected";
    if (!@function_exists("gzcompress")) $disable_zip=" disabled"; else $disable_zip=" selected";
    if ($disable_gzip!=" selected" && $disable_zip!=" selected") $disable_off=" selected";
        elseif($disable_gzip==" selected" && $disable_zip==" selected") $disable_zip="";
	if (count(PMBP_get_db_list())>0) foreach(PMBP_get_db_list() as $db) echo "<option value=\"".$db."\">".$db."</option>\n";
	    else echo "<option></option>\n";
    echo "</select>\n<br>";
    echo PMBP_set_select("backup","db[]","[".F_SELECT_ALL."]");
    echo "\n</td>\n<td>&nbsp;</td>\n<td>\n";
	echo "<textarea name=\"comments\" rows=\"9\" cols=\"80\"></textarea>\n<br>
<input type=\"checkbox\" name=\"tables\" checked>".F_EX_TABLES." |
<input type=\"checkbox\" name=\"data\" checked>".F_EX_DATA." |
<input type=\"checkbox\" name=\"drop\" checked>".F_EX_DROP." |
".F_EX_COMP."
<select name=\"zip\">
<option".$disabled_off." value=\"\">".F_EX_OFF."</option>
<option".$disable_gzip." value=\"gzip\">".F_EX_GZIP."</option>
<option".$disable_zip." value=\"zip\">".F_EX_ZIP."</option>
</select>\n</td>\n</tr>\n</table>\n<p></p>\n";

	// show directory backup form
	if ($CONF['dir_backup']) {
	$dirs1=PMBP_get_dirs("../");

    echo "\n\n<table width=\"940\">\n";
	echo "<tr>\n<td>\n";
    echo EX_DIRS.":<br>\n";
    echo "</td>\n<td>&nbsp;</td>\n<td>\n";
	echo EX_DIRS_MAN.":<br>\n";
    echo "</td>\n</tr><tr>\n<td>";
	echo "<select name='dirs[]' multiple=\"multiple\" size=\"10\">";
    foreach($dirs1 as $value) echo "<option value=\""."../".$value."\">"."../".$value."</option>\n";
	echo "</select>\n";
    echo "\n</td>\n<td>&nbsp;</td>\n<td>\n";
	echo "<textarea rows=\"9\" cols=\"63\" name=\"man_dirs\"></textarea>";
	echo "</td>\n</tr>\n</table>\n<p></p>\n";
	}
}


// generates image tag
function PMBP_image_tag($image,$alt="",$title="",$link=""){
	if (strpos($image,"/")==0) {
		$image=IMAGE_DIR.$image;
	    $size=getimagesize($image);
	} else {
	    $size=getimagesize(IMAGE_DIR.basename($image));
	}
	if ($link)
		return "<a href=\"".$link."\"><img src=\"".$image."\" alt=\"".$alt."\" title=\"".$alt."\" ".$size[3]."></a>";
	else
		return "<img src=\"".$image."\" alt=\"".$alt."\" title=\"".$alt."\" ".$size[3].">";
}


// generates javascript 'select all in input select' link
function PMBP_set_select($form,$select,$link){
    return "<a href=\"\" onclick=\"setSelect('".$form."','".$select."'); return false;\">".$link."</a>";
}


// generates javascript PMBP_pop_up link
function PMBP_pop_up($path,$link,$type){
    return "<a href='javascript:popUp(\"".$path."\",\"".$type."\")'>".$link."</a>";
}


// generates event hanlders to change the border color in a td.list list
function PMBP_change_color($color1,$color2){
    return "onmouseout=\"changeColor(this, '".$color1."');\" onmouseover=\"changeColor(this, '".$color2."');\"";
}


// generates javascript confirm dialog
function PMBP_confirm($text,$path,$link){
    global $CONF;
    switch ($CONF['confirm']) {
        case 0: return "<a href='javascript:confirmClick(\"".$text."\",\"".$path."\")'>".$link."</a>";
        case 1: {
            if (strstr($path,"all") || strstr($path,"ALL")) return "<a href='javascript:confirmClick(\"".$text."\",\"".$path."\")'>".$link."</a>";
                else return "<a href=\"".$path."\">".$link."</a>";
        }
        case 2: {
            if (strstr($path,"ALL")) return "<a href='javascript:confirmClick(\"".$text."\",\"".$path."\")'>".$link."</a>";
                else return "<a href=\"".$path."\">".$link."</a>";
        }
        case 3: return "<a href=\"".$path."\">".$link."</a>";
    }
}


// generates a dump of $db database
// $tables and $data set whether tables or data to backup. $comment sets the commment text
// $drop and $zip tell if to include the drop table statement or dry to pack
function PMBP_dump($db,$tables,$data,$drop,$zip,$comment) {
    global $CONF;
    $error=FALSE;
    
    // set max string size before writing to file
    $max_size=1048576*2; // 2 MB
    // changes max size if value can be retrieved
    if (ini_get("memory_limit")) $max_size=900000*ini_get("memory_limit");
    
    // set backupfile name
    if ($zip=="gzip") $backupfile=$db.".".$time=time().".sql.gz";
        elseif($zip=="zip") $backupfile=$db.".".($time=time()).".sql.zip";
            else $backupfile=$db.".".$time=time().".sql";
                    
    if ($con=@mysql_connect($CONF['sql_host'],$CONF['sql_user'],$CONF['sql_passwd'])) {

        // select db
        @mysql_select_db($db);

        //create comment
        $out="# MySQL dump of database '".$db."' on host '".$CONF['sql_host']."'\n";
        $out.="# backup date and time: ".strftime($CONF['date'],$time)."\n";
        $out.="# built by phpMyBackupPro ".VERSION."\n";
        $out.="# ".WEBSITE."\n\n";

        // write users comment
        if ($comment) {
            $out.="# comment:\n";
            $comment=preg_replace("'\n'","\n# ","# ".$comment);
            foreach(explode("\n",$comment) as $line) $out.=$line."\n";
            $out.="\n";
        }
        
        $out.="use ".$db.";\n";

        // get auto_increment values and names of all tables
        $res=mysql_query("show table status");
        $all_tables=array();
        while($row=@mysql_fetch_array($res)) $all_tables[]=$row;
        // get table structures
        foreach ($all_tables as $table) {
        	$res1=mysql_query("SHOW CREATE TABLE `".$table['Name']."`");
        	$tmp=mysql_fetch_array($res1);
        	$table_sql[$table['Name']]=$tmp["Create Table"];
        }

        // find foreign keys
        $fks=array();
        if (isset($table_sql))
	        foreach($table_sql as $tablenme=>$table) {
	            $tmp_table=$table;
			 // save all tables, needed for creating this table in $fks
				while (($ref_pos=strpos($tmp_table," REFERENCES "))>0) {
		   			$tmp_table=substr($tmp_table,$ref_pos+12);
		            $ref_pos=strpos($tmp_table,"(");
		            $fks[$tablenme][]=substr($tmp_table,0,$ref_pos);
				}
	        }

		// order $all_tables
		$all_tables=PMBP_order_sql_tables($all_tables,$fks);

        // as long as no error occurred
        if (!$error) {
	        #while($row=@mysql_fetch_array($res)) {
	        foreach ($all_tables as $row) {
	            $tablename=$row['Name'];
	            $auto_incr[$tablename]=$row['Auto_increment'];

	            $out.="\n\n";
	            // export tables
	            if ($tables) {
	                $out.="### structure of table `".$tablename."` ###\n\n";
	                if ($drop) $out.="DROP TABLE IF EXISTS `".$tablename."`;\n\n";
					$out.=$table_sql[$tablename];

	                // add auto_increment value
	                if ($auto_incr[$tablename]) {
	                    $out.=" AUTO_INCREMENT=".$auto_incr[$tablename];
	                }
	                $out.=" ;";
	            }
	            $out.="\n\n\n";

	            // export data
	            if ($data && !$error) {
	                $out.="### data of table `".$tablename."` ###\n\n";

					// check if field types are NULL or NOT NULL
					$res3=mysql_query("show columns from `".$tablename."`");
					
					$field_type=array();
					for ($j=0;$j<mysql_num_rows($res3);$j++){
						$row3=mysql_fetch_array($res3);
						$field_type[]=$row3[2];
					}

					$res2=mysql_query("select * from `".$tablename."`");
	                for ($j=0;$j<mysql_num_rows($res2);$j++){
	                    $out .= "insert into `".$tablename."` values (";
						$row2=mysql_fetch_row($res2);
						// run through each field
	                    for ($k=0;$k<$nf=mysql_num_fields($res2);$k++) {
	                        // identify null values and save them as null instead of ''
	                        if ($field_type[$k]!="" && $row2[$k]=="") $out .="null"; else $out .="'".mysql_escape_string($row2[$k])."'";
	                        if ($k<($nf-1)) $out .=", ";
	                    }
	                	$out .=");\n";

	                	// if saving is successful, then empty $out, else set error flag
	                	if (strlen($out)>$max_size && $zip!="zip") {
							if ($out=PMBP_save_to_file($backupfile,$zip,$out)) $out=""; else $error=TRUE;
	                	}
	                }

				// an error occurred! Try to delete file and return error status
	            } elseif ($error) {
	                @unlink("./".EXPORT_DIR.$backupfile);
	                return FALSE;
	            }

	            // if saving is successful, then empty $out, else set error flag
	            if (strlen($out)>$max_size && $zip!="zip") {
					if ($out=PMBP_save_to_file($backupfile,$zip,$out)) $out=""; else $error=TRUE;
	            }
	        }
	        
        // an error occurred! Try to delete file and return error status
        } else {
            @unlink("./".EXPORT_DIR.$backupfile);
            return FALSE;
        }
        
        // if (mysql_error()) return "DB_ERROR";
        @mysql_close($con);
        
        if ($zip=="zip") $zip=$time;
        if ($backupfile=PMBP_save_to_file($backupfile,$zip,$out)) {
			return $backupfile;
		} else {
		    @unlink("./".EXPORT_DIR.$backupfile);
			return FALSE;
		}
    } else {
        return "DB_ERROR";
    }
}


// orders the tables in $tables according to the constraints in $fks
// $fks musst be filled like this: $fks[tablename][0]=needed_table1; $fks[tablename][1]=needed_table2; ...
function PMBP_order_sql_tables($tables,$fks) {
	// do not order if no contraints exist
	if (!count($fks)) return $tables;

	// order
	$new_tables=array();
	$existing=array();
	$modified=TRUE;
	while(count($tables) && $modified==TRUE) {
	 	$modified=FALSE;
	    foreach($tables as $key=>$row) {
	        // delete from $tables and add to $new_tables
	        if (isset($fks[$row['Name']])) {
	        	foreach($fks[$row['Name']] as $needed) {
	            	// go to next table if not all needed tables exist in $existing
	                if(!in_array($needed,$existing)) continue 2;
	            }
	        }
                // delete from $tables and add to $new_tables
	            $existing[]=$row['Name'];
				$new_tables[]=$row;
            	prev($tables);
            	unset($tables[$key]);
            	$modified=TRUE;

	    }
	}

	if (count($tables)) {
	    // probably there are 'circles' in the constraints, bacause of that no proper backups can be created yet
	    // TODO: this will be fixed sometime later through using 'alter table' commands to add the constraints after generating the tables
	    // until now, just add the lasting tables to $new_tables, return them and print a warning
	    foreach($tables as $row) $new_tables[]=$row;
	    echo "<div class=\"red_left\">THIS DATABASE SEEMS TO CONTAIN 'RING CONSTRAINTS'. pMBP DOES NOT SUPPORT THEM. PROBABLY THE FOLOWING BACKUP IS DEFECT!</div>";
	}
	return $new_tables;
}


// saves the string in $fileData to the file $backupfile as gz file or not ($zip)
// returns backup file name if name has changed (zip), else TRUE. If saving failed, return value is FALSE
function PMBP_save_to_file($backupfile,$zip,$fileData) {
    if ($zip=="gzip") {
        if ($zp=@gzopen("./".EXPORT_DIR.$backupfile,"a9")) {
			@gzwrite($zp,$fileData);
			@gzclose($zp);
			return $backupfile;
        } else {
        	return FALSE;
        }
        
    // $zip contains the timestamp
    } elseif ($zip) {
        // based on zip.lib.php 2.2 from phpMyBackupAdmin
        // offical zip format: http://www.pkware.com/appnote.txt
        
        // End of central directory record
        $eof_ctrl_dir = "\x50\x4b\x05\x06\x00\x00\x00\x00";

        // "local file header" segment
        $unc_len=strlen($fileData);
        $crc=crc32($fileData);
        $zdata=gzcompress($fileData);

        // string needed for decoding (because of crc bug)
        $name_suffix=substr($zdata,-4,4);
        $name_suffix2="_";
        for($i=0;$i<4;$i++) $name_suffix2.=sprintf("%03d",ord($name_suffix[$i]));
        $backupfile=substr($backupfile,0,strlen($backupfile)-8).$name_suffix2.".sql.zip";
        $name=substr($backupfile,0,strlen($backupfile)-4);

        // fix crc bug
        $zdata=substr(substr($zdata,0,strlen($zdata)-4),2);
        $c_len=strlen($zdata);

        // dos time
        $timearray = getdate($zip);
        $dostime=(($timearray['year']-1980)<<25)|($timearray['mon']<<21)|($timearray['mday']<<16)|
            ($timearray['hours']<<11)|($timearray['minutes']<<5)|($timearray['seconds']>>1);
        $dtime=dechex($dostime);
        $hexdtime = "\x".$dtime[6].$dtime[7]."\x".$dtime[4].$dtime[5]."\x".$dtime[2].$dtime[3]."\x".$dtime[0].$dtime[1];
        eval('$hexdtime="'.$hexdtime.'";');

        // ver needed to extract, gen purpose bit flag, compression method, last mod time and date
        $sub1="\x14\x00"."\x00\x00"."\x08\x00".$hexdtime;

        // crc32, compressed filesize, uncompressed filesize
        $sub2=pack('V',$crc).pack('V',$c_len).pack('V',$unc_len);
        
        $fr="\x50\x4b\x03\x04".$sub1.$sub2;
        
        // length of filename, extra field length
        $fr.=pack('v',strlen($name)).pack('v',0);
        $fr.=$name;

        // "file data" segment and "data descriptor" segment (optional but necessary if archive is not served as file)
        $fr.=$zdata.$sub2;

        // now add to central directory record
        $cdrec="\x50\x4b\x01\x02";
        $cdrec.="\x00\x00";                // version made by
        $cdrec.=$sub1.$sub2;
        
         // length of filename, extra field length, file comment length, disk number start, internal file attributes, external file attributes - 'archive' bit set, offset
        $cdrec.=pack('v',strlen($name)).pack('v',0).pack('v',0).pack('v',0).pack('v',0).pack('V',32).pack('V',0);
        $cdrec.=$name;

        // combine data
        $fileData=$fr.$cdrec.$eof_ctrl_dir;
        
        // total # of entries "on this disk", total # of entries overall, size of central dir, offset to start of central dir, .zip file comment length
        $fileData.=pack('v',1).pack('v',1).pack('V',strlen($cdrec)).pack('V',strlen($fr))."\x00\x00";
        
        if ($zp=@fopen("./".EXPORT_DIR.$backupfile,"a")) {
			@fwrite($zp,$fileData);
			@fclose($zp);
			return $backupfile;
        } else {
        	return FALSE;
        }
        
	// uncompressed
    } else {
        if ($zp=@fopen("./".EXPORT_DIR.$backupfile,"a")) {
			@fwrite($zp,$fileData);
			@fclose($zp);
			return $backupfile;
        } else {
        	return FALSE;
        }
    }
}


// deletes $files backup files from $server ftp server in $path path using $user username and $pass password
function PMBP_ftp_del($files) {
    global $CONF;
    $out=FALSE;

    // try to connect to server using username and passwort
    if (!$CONF['ftp_server']) {
        $out.="<div class=\"red\">".C_WRONG_FTP."</div>";
    } elseif (!$conn_id=@ftp_connect($CONF['ftp_server'],$CONF['ftp_port'])) {
        $out.="<div class=\"red\">".F_FTP_1." '".$CONF['ftp_server']."'!</div>";
    } else {
        if (!$login_result=@ftp_login($conn_id,$CONF['ftp_user'],$CONF['ftp_passwd'])) {
            $out.="<div class=\"red\">".F_FTP_2." '".$CONF['ftp_user']."'.</div>";
        } else {

            // succesfully connected
            if ($CONF['ftp_pasv']) ftp_pasv($conn_id,TRUE); else ftp_pasv($conn_id,FALSE);

            // get files in remote directory
            if (!$CONF['ftp_path']) $path="."; else $path=$CONF['ftp_path'];
            $remote_files=ftp_nlist($conn_id,$path);
            
			if (is_array($remote_files)) {
				// separate filename
				for($i=0;$i<count($remote_files);$i++)
				    if (strrchr($remote_files[$i],"/")) $remote_files[$i]=substr(strrchr($remote_files[$i],"/"),1);
            
	            // delete the files
				foreach($files as $filename) {
        	        if (in_array($filename,$remote_files)) {
            	        $dest_file=$path."/".$filename;

                 	   // try three times to delete
                    	$check=FALSE;
	                    for($i=0;$i<3;$i++) if (!$check) $check=@ftp_delete($conn_id,$dest_file);
    	                if (!$check) $out.="<div class=\"red\">".sprintf(F_FTP_5."</div>\n",$dest_file);
        	                else $out.="<div class=\"green\">".sprintf(F_FTP_6."</div>\n",$dest_file);
            	    } else {
                	    $out.="<div class=\"red\">".sprintf(F_FTP_7."<br>\n",$filename)."</div>\n";
	                }
    	        }
			}

            // close the FTP connection
            if (@function_exists("ftp_close")) @ftp_close($conn_id);
        }
    }
    return $out;
}


// saves $files backup files on $server ftp server in $path path using $user username and $pass password
function PMBP_ftp_store($files) {
    global $CONF;
    $out=FALSE;
    
    // try to connect to server using username and passwort
    if (!$CONF['ftp_server']) {
        $out.="<div class=\"red\">".C_WRONG_FTP."!</div>";
    } elseif (!$conn_id=@ftp_connect($CONF['ftp_server'],$CONF['ftp_port'])) {
        $out.="<div class=\"red\">".F_FTP_1." '".$CONF['ftp_server']."'!</div>";
    } else {
        if (!$login_result=@ftp_login($conn_id,$CONF['ftp_user'],$CONF['ftp_passwd'])) {
            $out.="<div class=\"red\">".F_FTP_2." '".$CONF['ftp_user']."'.</div>";
        } else {

            // succesfully connected
            if ($CONF['ftp_pasv']) ftp_pasv($conn_id,TRUE); else ftp_pasv($conn_id,FALSE);
            if (!$CONF['ftp_path']) $path="."; else $path=$CONF['ftp_path'];
                
            // upload the files
            foreach($files as $filename) {
                $dest_file=$path."/".$filename;
                $source_file="./".EXPORT_DIR.$filename;

                // try three times to upload
                $check=FALSE;
                for($i=0;$i<3;$i++) if (!$check) $check=@ftp_put($conn_id,$dest_file,$source_file,FTP_BINARY);
                if (!$check) $out.="<div class=\"red\">".F_FTP_3.": '".$source_file."' -> '".$dest_file."'.</div>\n";
                    else $out.="<div class=\"green\">".F_FTP_4." '".$dest_file."'.</div>\n";
            }

            // close the FTP connection
            if (@function_exists("ftp_close")) @ftp_close($conn_id);
        }
    }
    return $out;
}


// send email with $attachments backup files to $email email using $sitename for sender and subject
function PMBP_email_store($attachments,$backup_info) {
    global $CONF;
    $out=FALSE;
    $all_emails=explode(",",$CONF['email']);
 
	// new mail script (since v.1.4)
	$mailtext.=F_MAIL_2." '".$CONF['sitename']."'.\r\n";
	if ($backup_info['comp']=="gzip") $mailtext.=INF_COMP.": gzip\r\n";
	    elseif ($backup_info['comp']=="zip") $mailtext.=INF_COMP.": zip\r\n";
	        else $mailtext.=INF_COMP.": ".F_NO."\r\n";
	if ($backup_info['drop']) $mailtext.=INF_DROP.": ".F_YES."\r\n"; else $mailtext.=INF_DROP.": ".F_NO."\r\n";
	if ($backup_info['tables']) $mailtext.=INF_TABLES.": ".F_YES."\r\n"; else $mailtext.=INF_TABLES.": ".F_No."\r\n";
	if ($backup_info['data']) $mailtext.=INF_DATA.": ".F_YES."\r\n"; else $mailtext.=INF_DATA.": ".F_NO."\r\n";
	$mailtext.=INF_COMMENT.":\r\n".$backup_info['comments'];
	srand((double)microtime()*1000000);
	$boundary = "=_".md5(uniqid(rand()).microtime());
	$parts[-1]="Content-Type: text/plain; charset=\"".BD_CHARSET_EMAIL."\"\r\n\r\n".$mailtext."\r\n";
	for ($i=0;$i<count($attachments);$i++) {
	    foreach (file(EXPORT_DIR.$attachments[$i]) as $val) $bodies[$i].=$val;
	    $bodies[$i]=rtrim(chunk_split(base64_encode($bodies[$i]), 76, "\r\n"))."\r\n";
	    $parts[$i]="Content-Type: application/zip; name=\"".$attachments[$i].
		"\"\r\nContent-Transfer-Encoding: base64\r\nContent-Disposition: attachment; filename=\"".$attachments[$i]."\"\r\n\r\n".$bodies[$i]."\r\n";
	}

	$encoded['body'] = "--".$boundary."\r\n".implode("--".$boundary."\r\n",$parts)."--".$boundary."--\r\n\r\n";
	$headers="From: phpMyBackupPro on ".$CONF['sitename']." <".$all_emails[0].">\r\nMime-Version: 1.0\r\nContent-Type: multipart/mixed;\r\n\tboundary=\"".$boundary."\"";

	// send to all every addresses
    foreach($all_emails as $email) {
	    // verify email
    	if (!eregi("^\ *[a-zA-Z0-9_-]+(\.[a-zA-Z0-9\._-]+)*@([a-zA-Z0-9-]+\.)+([a-z]{2,4})$",$email)) {
        	$out.="<div class=\"red\">".F_MAIL_1."</div>\n";
			continue;
    	}
    }

    // send mail
   	if (!@mail($CONF['email'],F_MAIL_4." ".$CONF['sitename'],$encoded['body'],$headers)) $out.="<div class=\"red\">".F_MAIL_5.".</div>\n";
        else $out.="<div class=\"green\">".F_MAIL_6." ".$CONF['email'].".</div>\n";
    
    return $out;
}


// returns actual local backup files after deleting backups files older then $deltime days
function PMBP_get_backup_files() {
    global $CONF;
    $delete_files=FALSE;
    $all_files=FALSE;
    $result_files=FALSE;
    $handle=@opendir("./".EXPORT_DIR);
    $remove_time=time()-($CONF['del_time']*86400);
    while ($file=@readdir($handle)) {
        if ($file!="." && $file!=".." && preg_match("'\.sql|\.sql\.gz|\.sql\.zip'",$file)) {
            
            // don't delete if del_time is false
            if (PMBP_file_info("time",$file)<$remove_time && $CONF['del_time']) $delete_files[]=$file; else $all_files[]=$file;
        }
    }
    
    // sort descending
    if (is_array($all_files)) rsort($all_files);
    
    // delete oldest backup files if there are to many for one db
    if (is_array($all_files))
        foreach($all_files as $file) {
            if (!isset($counter[$db=PMBP_file_info("db","./".EXPORT_DIR.$file)])) $counter[$db]=1; else $counter[$db]++;
            if ($counter[$db]>$CONF['del_number']) $delete_files[]=$file; else $result_files[]=$file;
        }

    // now delete the files
    if ($delete_files) PMBP_delete_backup_files($delete_files);

    // sort ascending
    if (is_array($result_files)) sort($result_files);
    return $result_files;
}


// delete the file(s) in mixed $files from local export dir and remote ftp server
function PMBP_delete_backup_files($files) {
    global $CONF;
    $out=FALSE;
    if(!is_array($files)) $files=array($files);
    foreach($files as $file) @unlink("./".EXPORT_DIR.$file);
    if ($CONF['ftp_use'] && $CONF['ftp_del']) $out=PMBP_ftp_del($files);
    return $out;
}


// returns list of databases on $host host using $user user and $passwd password
function PMBP_get_db_list() {
    global $CONF;

    // if there is given the name of a single database
    if ($CONF['sql_db']) return array($CONF['sql_db']);
    
    // else try to get a list of all available databases on the server
    $list=array();
    $con=@mysql_connect($CONF['sql_host'],$CONF['sql_user'],$CONF['sql_passwd']);
    $db_list=@mysql_list_dbs();
    while ($row=@mysql_fetch_array($db_list))
        if (@mysql_select_db($row['Database'])) $list[]=$row['Database'];
    return $list;
}


// in dependency on $mode different modes can be selected (see below)
function PMBP_file_info($mode,$path) {
    $filename=ereg_replace(".*/","",$path);
    $parts=explode(".",$filename);
    switch($mode) {
    
        // returns the name of the database a $path backup file belongs to
        case "db":
            return $parts[0];
        break;

        // returns the creation timestamp $path backup file
        case "time":
            return $parts[1];
        break;
        
        // returns "gz" if $path backup file is gziped
        case "gzip":
            if (isset($parts[3])) if ($parts[3]=="gz") return $parts[3];
        break;
        
        // returns "zip" if $path backup file is ziped
        case "zip":
            if (isset($parts[3])) if ($parts[3]=="zip") return $parts[3];
        break;
        
        // returns type of compression of $path backup file or no
        case "comp":
            if (PMBP_file_info("gzip",$path)) return "gzip"; elseif (PMBP_file_info("zip",$path)) return "zip"; else return F_NO;
        break;

        // returns the size of $path backup file
        case "size":
            return filesize($path);
        break;

        // returns yes if the backup file contains 'drop table if exists' or no if not
        case "drop":
            if (($comp=PMBP_file_info("comp",$path))=="gzip") $lines=PMBP_ungzip("lines",$path);
                elseif ($comp=="zip") $lines=PMBP_unzip("lines",$path);
                    else $lines=file($path);
            foreach($lines as $line){
                $line=trim($line);
                if (strtolower(substr($line,0,20))=="drop table if exists") return F_YES; else $drop=F_NO;
            }
            return $drop;

        break;
        
        // returns yes if the $path backup files contains tables or no if not
        case "tables":
            if (($comp=PMBP_file_info("comp",$path))=="gzip") $lines=PMBP_ungzip("lines",$path);
                elseif ($comp=="zip") $lines=PMBP_unzip("lines",$path);
                    else $lines=file($path);
            foreach($lines as $line){
                $line=trim($line);
                if (strtolower(substr($line,0,6))=="create") return F_YES; else $table=F_NO;
            }
            return $table;
        break;

        // returns yes if the $path backup files contains data or no if not
        case "data":
            if (($comp=PMBP_file_info("comp",$path))=="gzip") $lines=PMBP_ungzip("lines",$path);
                elseif ($comp=="zip") $lines=PMBP_unzip("lines",$path);
                    else $lines=file($path);
            foreach($lines as $line){
                $line=trim($line);
                if (strtolower(substr($line,0,6))=="insert") return F_YES; else $data=F_NO;
            }
            return $data;
        break;
        
        // returns the comment stored to the backup file
        case "comment":
            if (($comp=PMBP_file_info("comp",$path))=="gzip") $lines=PMBP_ungzip("lines",$path);
                elseif ($comp=="zip") $lines=PMBP_unzip("lines",$path);
                    else $lines=file($path);
            foreach($lines as $line){
                $line=trim($line);
                if (isset($comment) && substr($line,0,1)=="#") $comment.=substr($line,2)."<br>";
                    elseif(isset($comment) && substr($line,0,1)!="#") return $comment;
                if ($line=="# comment:") $comment=FALSE;
            }
            if (isset($comment)) return $comment; else return FALSE;
        break;
    }
}


// returns the content of the gziped $path backup file. use of $mode see below
function PMBP_ungzip($mode,$path) {
    $file_data=gzfile($path);
    // returns one string or an array of lines
    if ($mode!="lines") return implode("",$file_data); else return $file_data;
}


// returns the content of the ziped $path backup file. use of $mode see below
function PMBP_unzip($mode,$path) {
    $all=FALSE;
    $all=implode("",file($path));

    // convert path to name of ziped file
    $filename=ereg_replace(".*/","",$path);
    $filename=substr($filename,0,strlen($filename)-4);
	
    // compare filname in zip and filename from $_GET
    if(substr($all,30,strlen($filename))!=$filename) {

        // exit if names differ
        echo F_WRONG_FILE.".";
        exit;
    } else {

        // get the suffix of the filename in hex
        $crc_bugfix=substr(substr($filename,0,strlen($filename)-4),strlen($filename)-12-4);
        $suffix=FALSE;

        // convert hex to ascii
        for($i=0;$i<12;) $suffix.=chr($crc_bugfix[$i++].$crc_bugfix[$i++].$crc_bugfix[$i++]);

        // remove central directory information (we have always just one ziped file)
        $comp=substr($all,-(strlen($all)-30-strlen($filename)));
        $comp=substr($comp,0,(strlen($comp)-80-strlen($filename)));

        // fix the crc bugfix (see function save_to_file)
        $comp="x".$comp.$suffix;
        $file_data=gzuncompress($comp);
    }

    // returns one string or an array of lines
    if ($mode!="lines") return $file_data; else return explode("\n",$file_data);
}


// determines the best size type for filesize $size and returns array('value'=xxx,'type'=yyy)
function PMBP_size_type($size) {
    $types=array("B","KB","MB","GB");
    for ($i=0; $size>1000; $i++,$size/=1024);
    $result['value']=round($size,2);
    $result['type']=$types[$i];
    return $result;
}


// get recursive directory list
function PMBP_get_dirs($dir) {
    $dirs=FALSE;
    $dir_handle=@opendir($dir);
    while ($file=@readdir ($dir_handle)) {
        if ($file!="." && $file!="..") {
            if (@is_dir($dir.$file)) {
                $dirs[]=$file."/";
                $tmp=PMBP_get_dirs($dir.$file."/");
                if (is_array($tmp)) foreach($tmp as $value) $dirs[]=$file."/".$value;
            }
        }
    }
    return $dirs;
}


// get list of all files in directory
function PMBP_get_files($dir) {
    $dirs=array();
    $dir=trim($dir);
	if ($dir_handle=@opendir($dir)) {
    	while (false!==($file=readdir($dir_handle))) {
    	if ($file!="." && $file!="..") {
	    		if (!is_dir($dir.$file)) {
					$dirs[]=$dir.$file;
				// recursive listing of files
	    		} elseif($CONF['dir_rec']) {
					$tmp=PMBP_get_files($dir.$file."/");
					if (is_array($tmp)) foreach($tmp as $value) $dirs[]=$value;
				}
	    	}
    	}
    	@closedir($dir_handle);
	}
    return $dirs;
}


// transfer files $files to FPT servers dirs and create missing folders
function PMBP_save_FTP($files) {
    global $CONF;
    $out=FALSE;

    // try to connect to server using username and passwort
    if (!$CONF['ftp_server']) {
        $out.="<div class=\"red\">".C_WRONG_FTP."</div>";
    } elseif (!$conn_id=@ftp_connect($CONF['ftp_server'],$CONF['ftp_port'])) {
        $out.="<div class=\"red\">".F_FTP_1." '".$CONF['ftp_server']."'!</div>";
    } else {
        if (!$login_result=@ftp_login($conn_id,$CONF['ftp_user'],$CONF['ftp_passwd'])) {
            $out.="<div class=\"red\">".F_FTP_2." '".$CONF['ftp_user']."'.</div>";
        } else {

            // succesfully connected -> set passive and change to the right path
            if ($CONF['ftp_pasv']) ftp_pasv($conn_id,TRUE); else ftp_pasv($conn_id,FALSE);
            if (!$CONF['ftp_path']) $path="."; else $path=$CONF['ftp_path'];
			@ftp_chdir($conn_id,$path);
			
            // create all missing folders
            foreach($files as $filepath) {
                if (trim($filepath)) {
					$filepath=trim($filepath);
	                $folders=explode("/",$filepath);
    	            $filename=array_pop($folders);
					$deep=0;
            	    $all_folders="";
                	foreach($folders as $folder) {
                    	if ($folder != "." && $folder != "..") {
							if (! @ftp_chdir($conn_id,$folder)) {
								@ftp_mkdir($conn_id,$folder);
								@ftp_chdir($conn_id,$folder);
							}
							$all_folders.=$folder."/";
        	                $deep++;
                	    }
	                }
	                
	                // change back to $path
    	            $rel_path="";
        	        for ($i=0;$i<$deep;$i++) $rel_path.="../";
					@ftp_chdir($conn_id,$rel_path);
                
					// define the source and destination pathes
	                $dest_file=$all_folders.$filename;
    	            $source_file="./".$filepath;

        	        // try three times to upload
            	    $check=FALSE;
                	for($i=0;$i<3;$i++) if (!$check) $check=@ftp_put($conn_id,$dest_file,$source_file,FTP_BINARY);
	                if (!$check) $out.="<div class=\"red\">".F_FTP_3.": '".$source_file."' -> '".$dest_file."'.</div>\n";
    	                else $out.="<div class=\"green\">".F_FTP_4." '".$dest_file."'.</div>\n";
        	    }
            }

            // close the FTP connection
            if (@function_exists("ftp_close")) @ftp_close($conn_id);
        }
    }
    return $out;
}


// login module
function PMBP_auth () {
	header("WWW-Authenticate: Basic realm=\"phpMyBackupPro\"");
	header("HTTP/1.0 401 Unauthorized");
    echo LI_MSG."\n";
}
?>
